import { UserConfig as ViteUserConfig, InlineConfig as ViteInlineConfig } from 'vite';
import { IRoute, IDynamicImport } from '@viterjs/renderer';
import { Overwrite } from '../utils';
import { BuildOptions } from './build';
export interface ConfigEnv {
    command: 'build' | 'serve';
    mode: string;
}
export declare type UserConfigFn = (env: ConfigEnv) => UserConfig | Promise<UserConfig>;
export declare type UserConfigExport = UserConfig | Promise<UserConfig> | UserConfigFn;
interface ViterUserConfig {
    /**
     * Base public path when served in development or production.
     * @default '/'
     */
    base?: string;
    /**
     * Base public path when served in development or production.
     * @default '/'
     */
    routes?: IRoute[];
    /**
     * Base public path when served in development or production.
     * @default '/'
     */
    dynamicImport?: IDynamicImport;
    /**
     * Base public path when served in development or production.
     * @default '/'
     */
    routerBase?: string;
    /**
     * Build specific options
     */
    build?: BuildOptions;
}
export declare type UserConfig = Overwrite<ViteUserConfig, ViterUserConfig>;
export declare type InlineConfig = UserConfig & Overwrite<ViteInlineConfig, {
    configFile?: string;
}>;
export declare type ResolvedConfig = UserConfig & {
    configFile: string | undefined;
    inlineConfig: InlineConfig;
};
export {};
